
// Analog_ViewerDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Analog_Viewer.h"
#include "Analog_ViewerDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAnalog_ViewerDlg-Dialogfeld



CAnalog_ViewerDlg::CAnalog_ViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_ANALOG_VIEWER_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAnalog_ViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_DEVICE, m_Device);
	DDX_Control(pDX, IDC_CMB_BYPASS, m_Bypass);
	DDX_Control(pDX, IDC_CMB_CHANNEL, m_Channel);
	DDX_Control(pDX, IDC_CMB_REFERENCE, m_Reference);

	DDX_Control(pDX, IDC_PROGRESS_CH1, m_ProgressCh[0]);
	DDX_Control(pDX, IDC_PROGRESS_CH2, m_ProgressCh[1]);
	DDX_Control(pDX, IDC_PROGRESS_CH3, m_ProgressCh[2]);
	DDX_Control(pDX, IDC_PROGRESS_CH4, m_ProgressCh[3]);
	DDX_Control(pDX, IDC_PROGRESS_CH5, m_ProgressCh[4]);
	DDX_Control(pDX, IDC_PROGRESS_CH6, m_ProgressCh[5]);
	DDX_Control(pDX, IDC_PROGRESS_CH7, m_ProgressCh[6]);
	DDX_Control(pDX, IDC_PROGRESS_CH8, m_ProgressCh[7]);

	DDX_Control(pDX, IDC_EDIT_CH1, m_EditCh[0]);
	DDX_Control(pDX, IDC_EDIT_CH2, m_EditCh[1]);
	DDX_Control(pDX, IDC_EDIT_CH3, m_EditCh[2]);
	DDX_Control(pDX, IDC_EDIT_CH4, m_EditCh[3]);
	DDX_Control(pDX, IDC_EDIT_CH5, m_EditCh[4]);
	DDX_Control(pDX, IDC_EDIT_CH6, m_EditCh[5]);
	DDX_Control(pDX, IDC_EDIT_CH7, m_EditCh[6]);
	DDX_Control(pDX, IDC_EDIT_CH8, m_EditCh[7]);

	DDX_Control(pDX, IDC_STATIC_CH1, m_TextCh[0]);
	DDX_Control(pDX, IDC_STATIC_CH2, m_TextCh[1]);
	DDX_Control(pDX, IDC_STATIC_CH3, m_TextCh[2]);
	DDX_Control(pDX, IDC_STATIC_CH4, m_TextCh[3]);
	DDX_Control(pDX, IDC_STATIC_CH5, m_TextCh[4]);
	DDX_Control(pDX, IDC_STATIC_CH6, m_TextCh[5]);
	DDX_Control(pDX, IDC_STATIC_CH7, m_TextCh[6]);
	DDX_Control(pDX, IDC_STATIC_CH8, m_TextCh[7]);
	DDX_Control(pDX, IDC_CHK_CONFIG, m_ChkConfig);
}

BEGIN_MESSAGE_MAP(CAnalog_ViewerDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_SEARCH, &CAnalog_ViewerDlg::OnBnClickedBtnSearch)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_CMB_DEVICE, &CAnalog_ViewerDlg::OnCbnSelchangeCmbDevice)
	ON_BN_CLICKED(IDC_CHK_CONFIG, &CAnalog_ViewerDlg::OnBnClickedChkConfig)
END_MESSAGE_MAP()


// CAnalog_ViewerDlg-Meldungshandler

BOOL CAnalog_ViewerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	CString text;

	m_TimerRun = false;
	m_Channel.SetCurSel(0);
	m_Reference.SetCurSel(0);
	m_Bypass.SetCurSel(0);

	for (int i = 0; i < 8; i++)
	{
		m_ProgressCh[i].SetRange(0, 0x3FFF);
		m_ProgressCh[i].SetPos(0);
		m_EditCh[i].SetWindowTextW(L"0");

		text.Format(L"Channel %d", i+1);
		m_TextCh[i].SetWindowTextW(text);
	}


	return TRUE;  
}


void CAnalog_ViewerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

HCURSOR CAnalog_ViewerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAnalog_ViewerDlg::OnClose()
{
	if (m_Handle != NULL)
	{
		if (idEvent > 0)
			timeKillEvent(idEvent);


		//Disable PWM mode
		IOWKIT56_SPECIAL_REPORT report;
		memset(&report, 0x00, IOWKIT56_SPECIAL_REPORT_SIZE);

		//Create report
		report.ReportID = 0x00;			//Special mod PWM output
		report.Bytes[0] = 0x00;			//Disable

		//Send report to IO-Warrior56
		IowKitWrite(m_SelectedHandle, IOW_PIPE_SPECIAL_MODE, (char*)&report, IOWKIT56_SPECIAL_REPORT_SIZE);

		//Dont forget to close !!!!
		IowKitCloseDevice(m_Handle);
	}

	CDialogEx::OnClose();
}


void CAnalog_ViewerDlg::OnBnClickedBtnSearch()
{
	IOWKIT_HANDLE tHandle = NULL;	//temp handle
	CString text;
	UINT pid;
	ULONG rev;
	int index = 0;	//index for m_Devices -> Only IOW56 supports PWM

	//Open iowkit API
	m_Handle = NULL;
	m_Handle = IowKitOpenDevice();

	m_Device.ResetContent();

	//One or more devices connected and iowkit not open by another application
	if (m_Handle != NULL)
	{
		//Get count of iows
		ULONG numDev = IowKitGetNumDevs();

		//Get unique handles for each connected iow
		for (ULONG i = 1; i <= numDev; i++)
		{
			//get handle
			tHandle = IowKitGetDeviceHandle(i);

			//Get product ID from tHandle
			pid = IowKitGetProductId(tHandle);
			rev = IowKitGetRevision(tHandle);

			//Get revision HEX from String
			long l = strtol("2000", NULL, 16);

			//Only IOW56 rev 2.0.0.0 supports PWM output
			if ((pid == IOWKIT_PID_IOW56) && (l <= rev))
			{
				m_Devices[index] = tHandle;
				text = GetProductStringExt(m_Devices[index]);
				m_Device.AddString(text);

				index++; //Count the IOW56 with rev >= 2.0.0.0
			}
		}

		if (index == 1)
		{
			m_Device.SetCurSel(0);
			m_SelectedHandle = m_Devices[0];
			IowKitSetTimeout(m_Devices[0], 2000);
		}
		else if (index == 0)
		{
			MessageBox(L"No IO-Warrior56 with rev. >= 2.0.0.0 found on USB.", L"Device error", MB_OK | MB_ICONERROR);
		}
		else
		{
			//Nothing
		}
	}
	else
	{
		MessageBox(L"No IO-Warrior found on USB.", L"Device error", MB_OK | MB_ICONERROR);
	}
}




void CAnalog_ViewerDlg::OnCbnSelchangeCmbDevice()
{
	m_SelectedHandle = m_Devices[m_Device.GetCurSel()];
}


void CALLBACK CAnalog_ViewerDlg::TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CAnalog_ViewerDlg* obj = (CAnalog_ViewerDlg*)dwUser;
	obj->MMTimerHandler(wTimerID);
}

/*Multimedia-Timer loop*/
void CAnalog_ViewerDlg::MMTimerHandler(UINT nIDEvent)
{
	CString text;
	IOWKIT56_SPECIAL_REPORT report;
	memset(&report, 0, IOWKIT56_SPECIAL_REPORT_SIZE);
	int value = 0;

	report.ReportID = 0x1D;
	
	if (m_SelectedHandle != NULL)
	{
		//Read data from IO-Warrior56
		if (IowKitRead(m_SelectedHandle, IOW_PIPE_SPECIAL_MODE, (char*)&report, IOWKIT56_SPECIAL_REPORT_SIZE) == IOWKIT56_SPECIAL_REPORT_SIZE)
		{
			value = GetADValue(report.Bytes[1], report.Bytes[0]);	//Create value
			m_ProgressCh[0].SetPos(value);							//Set progressbar
			SetTextfield(IDC_EDIT_CH1, value);						//Set static output

			value = GetADValue(report.Bytes[3], report.Bytes[2]);
			m_ProgressCh[1].SetPos(value);
			SetTextfield(IDC_EDIT_CH2, value);

			value = GetADValue(report.Bytes[5], report.Bytes[4]);
			m_ProgressCh[2].SetPos(value);
			SetTextfield(IDC_EDIT_CH3, value);

			value = GetADValue(report.Bytes[7], report.Bytes[6]);
			m_ProgressCh[3].SetPos(value);
			SetTextfield(IDC_EDIT_CH4, value);

			value = GetADValue(report.Bytes[9], report.Bytes[8]);
			m_ProgressCh[4].SetPos(value);
			SetTextfield(IDC_EDIT_CH5, value);

			value = GetADValue(report.Bytes[11], report.Bytes[10]);
			m_ProgressCh[5].SetPos(value);
			SetTextfield(IDC_EDIT_CH6, value);

			value = GetADValue(report.Bytes[13], report.Bytes[12]);
			m_ProgressCh[6].SetPos(value);
			SetTextfield(IDC_EDIT_CH7, value);

			value = GetADValue(report.Bytes[15], report.Bytes[14]);
			m_ProgressCh[7].SetPos(value);
			SetTextfield(IDC_EDIT_CH8, value);
		}
	}
}


int CAnalog_ViewerDlg::GetADValue(BYTE msb, BYTE lsb)
{
	int res = (msb << 8) | lsb;
	return res;
}


void CAnalog_ViewerDlg::SetTextfield(UINT field, int value)
{
	CString text;
	text.Format(_T("%d"), value);
	GetDlgItem(field)->SetWindowTextW(text);
}


void CAnalog_ViewerDlg::OnBnClickedChkConfig()
{
	//UpdateData(TRUE);

	IOWKIT56_SPECIAL_REPORT report;
	memset(&report, 0, IOWKIT56_SPECIAL_REPORT_SIZE);

	report.ReportID = 0x1C;						//Special mode ADC

	if((m_ChkConfig.GetState() & BST_CHECKED) == BST_CHECKED)
		report.Bytes[0] = 0x01;						//Enable
	else
		report.Bytes[0] = 0x00;						//Disable
	
	report.Bytes[1] = m_Channel.GetCurSel()+1;	//Channel ->
	report.Bytes[2] = m_Reference.GetCurSel();	//Reference
	report.Bytes[3] = m_Bypass.GetCurSel();		//Bypass Enabled / Disabled

	IowKitWrite(m_SelectedHandle, IOW_PIPE_SPECIAL_MODE, (char*)&report, IOWKIT56_SPECIAL_REPORT_SIZE);

	//UpdateData(FALSE);

	
	if (m_TimerRun == false)
	{
		if (m_SelectedHandle != NULL)
		{
			//Multimedia-Timer BEGIN
			TIMECAPS tc;
			timeGetDevCaps(&tc, sizeof(TIMECAPS));
			DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
			timeBeginPeriod(resolution);
			UINT ms = 2; //Set timer to 2 ms -> Max speed of IOW56

			idEvent = timeSetEvent(ms, resolution, TimerFunction, (DWORD)this, TIME_PERIODIC);

			m_TimerRun = true;
			m_Device.EnableWindow(FALSE);
			GetDlgItem(IDC_BTN_SEARCH)->EnableWindow(FALSE);
			m_Bypass.EnableWindow(FALSE);
			m_Reference.EnableWindow(FALSE);
			m_Channel.EnableWindow(FALSE);
		}
	}
	else
	{
		//Mulitmedia-Timer DIE
		timeKillEvent(idEvent);
		idEvent = 0;

		m_TimerRun = false;
		m_Device.EnableWindow(TRUE);
		GetDlgItem(IDC_BTN_SEARCH)->EnableWindow(TRUE);
		m_Bypass.EnableWindow(TRUE);
		m_Reference.EnableWindow(TRUE);
		m_Channel.EnableWindow(TRUE);
	}

}
