﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace rc5
{
    public partial class Form1 : Form
    {
        public IntPtr handle;
        public Boolean timer;
        public Boolean state;
        public byte laststate;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            timer = false;
            state = false;
            laststate = 0;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            //Close Devices and DLL
            Functions.IowKitCloseDevice(handle);
        }

        private void connect_Click(object sender, EventArgs e)
        {
            //Open Device and get first device Handle which found
            handle = Functions.IowKitOpenDevice();

            //Device found?
            if (handle != IntPtr.Zero)
            {
                StringBuilder sn = new StringBuilder();

                //Get ProductID
                uint pid = Functions.IowKitGetProductId(handle);

                //Get serial number
                Functions.IowKitGetSerialNumber(handle, sn);

                //RC5 only works with IO-Warrior24
                if (pid != Defines.IOWKIT_PID_IOW24)
                {
                    MessageBox.Show("No IO-Warrior24 Connected", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                else
                {
                    serial.Text = sn.ToString();
                    device.Text = "IO-Warrior24";
                }
            }
            else
            {
                MessageBox.Show("No Device Found", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void start_Click(object sender, EventArgs e)
        {
            //report Structure for IO-Warrior
            byte[] report = new byte[8];

            if (handle != IntPtr.Zero)
            {
                //Enable RC5 Mode
                report[0] = 0x0C;
                report[1] = 0x01;
                Functions.IowKitWrite(handle, Defines.IOW_PIPE_SPECIAL_MODE, report, 8);


                if (timer == false)
                {
                    timer1.Enabled = true;
                    timer1.Start();
                    start.Text = "Stop";
                    timer = true;
                }
                else
                {
                    timer1.Enabled = false;
                    timer1.Stop();
                    start.Text = "Start";
                    timer = false;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] report = new byte[8];

            //Read Data from device
            Functions.IowKitReadNonBlocking(handle, Defines.IOW_PIPE_SPECIAL_MODE, report, 8);

            //If data available and state not the last one
            if ((report[2] != laststate) && (report[2] != 0))
            {
                list.Items.Insert(0, "Data: " + report[1].ToString("X") + " - " + "State: " + report[2].ToString("X"));
                laststate = report[2];
            }
        }
    }
}
