#include "stdafx.h"
#include <locale.h>
//#include "trace.h"

void TraceString(CString value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%s\r\n"), prefix, value);
	OutputDebugString(text);
}

void TraceByte(BYTE value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%02X\r\n"), prefix, value);
	OutputDebugString(text);
}

void Trace4Byte(BYTE b1, BYTE b2, BYTE b3, BYTE b4, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%02X %02X %02X %02X\r\n"), prefix, b1, b2, b3, b4);
	OutputDebugString(text);
}

void TraceInt(int value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%d\r\n"), prefix, value);
	OutputDebugString(text);
}

void TraceIntExt(int value, CString prefix = NULL, wchar_t delimiter = '.')
{
	CString text;
	CString zahl;

	zahl.Format(_T("%d"), value);

	for (int nIdx = zahl.GetLength() - 3; nIdx > 0; nIdx -= 3)
		zahl.Insert(nIdx, delimiter);

	text.Format(_T("%s%s\r\n"), prefix, zahl);

	OutputDebugString(text);
}

void TraceFloat(float value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%f\r\n"), prefix, value);
	OutputDebugString(text);
}

void TraceLong(long value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%f\r\n"), prefix, value);
	OutputDebugString(text);
}


void TraceDword(DWORD value, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%04x\r\n"), prefix, value);
	OutputDebugString(text);
}

void TraceByteArray(BYTE value[], int size, CString prefix = NULL)
{
	CString text, t;

	for (int i = 0; i < size; i++)
	{
		text.Format(_T("%s%02x "), prefix, value[i]);
		t.Append(text);
	}
		
	t.Append(_T("\n"));
	OutputDebugString(t);
}

void TraceByteInt(BYTE b, CString prefix = NULL)
{
	CString text;
	text.Format(_T("%s%02X \t (%d)\r\n"), prefix, b, b);
	OutputDebugString(text);
}

void TraceReport(IOWKIT_SPECIAL_REPORT report, CString prefix = NULL)
{
	CString text, t;
	t.Format(_T("%s%02x "), prefix, report.ReportID);

	for (int i = 0; i <= 6; i++)
	{
		text.Format(_T("%02x "), report.Bytes[i]);
		t.Append(text);
	}
	
	t.Append(_T("\n"));
	OutputDebugString(t);
}

void TraceReport56(IOWKIT56_SPECIAL_REPORT report, CString prefix = NULL)
{
	CString text, t;
	t.Format(_T("%s%02x "), prefix, report.ReportID);

	for (int i = 0; i < 63; i++)
	{
		text.Format(_T("%02x "), report.Bytes[i]);
		t.Append(text);
	}

	t.Append(_T("\n"));
	OutputDebugString(t);
}