Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	Dim IOWarrior As Integer
	Dim Pid As Integer
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim I As Integer
		Dim Report(64) As Byte
		
		' open the IO-Warriors
		IOWarrior = IowKitOpenDevice
		Pid = IowKitGetProductId(IOWarrior)
		If Pid <> IOWKIT_PID_IOW24 And Pid <> IOWKIT_PID_IOW56 Then
			' Exit from program
			MsgBox("No IOWarrior 24 or 56 found!", 0, "Error")
			End
		End If
		
		' if found activate SPI
		If Pid = IOWKIT_PID_IOW24 Then
			Report(0) = &H8s
			Report(1) = &H1s ' enable SPI
			Report(2) = &H7s ' mode /CPOL, CPHA, 62.5 KBit
			I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 8)
		Else
			Report(0) = &H8s
			Report(1) = &H1s ' Enable SPI
			Report(2) = &H1s ' mode MSB first, /CPOL, CPHA
			Report(3) = &H0s ' 93.75 KBit
			I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 64)
		End If
		' start timer for reading temperature
		Timer1.Enabled = True
	End Sub
	
	Private Sub Form1_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		Dim I As Integer
		Dim Report(8) As Byte
		
		' stop timer
		Timer1.Enabled = False
		' deactivate SPI
		If IOWarrior <> 0 Then
			Report(0) = &H8s
			Report(1) = &H0s
			Report(2) = &H0s
			If Pid = IOWKIT_PID_IOW24 Then
				I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 8)
			Else
                I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 64)
			End If
		End If
		' close IO-Warriors
		IowKitCloseDevice((IOWarrior))
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		Dim I As Integer
		Dim Report(64) As Byte
		
		' write 2 bytes of dummy data to SPI to trigger read
		Report(0) = &H9s
		Report(1) = &H2s
		Report(2) = &H0s
		If Pid = IOWKIT_PID_IOW24 Then
			I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 8)
			' read temperature data
			I = IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 8)
		Else
			I = IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 64)
			' read temperature data
			I = IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, Report(0), 64)
		End If
		' build 16 bit value and shift it 3 bits to the right
		I = (Report(2) * 256 + Report(3)) / 8
		' values is in 1/4 degree Celsius
		Label1.Text = VB6.Format(I / 4, "0.00 C")
	End Sub
End Class